Bug 1571898 - uncomfortable missing debuginfo handling
Summary: uncomfortable missing debuginfo handling
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: gdb
Version: 33
Hardware: Unspecified
OS: Unspecified
unspecified
low
Target Milestone: ---
Assignee: Kevin Buettner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-04-25 15:56 UTC by Germano Massullo
Modified: 2020-10-02 19:25 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Germano Massullo 2018-04-25 15:56:35 UTC
Description of problem:
GDB complains about missing debuginfo in a very peculiar way, for example:

Missing separate debuginfo for /lib64/libx264.so.148
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ee/241d6a833a2b4aadd9c9d24466002df2bce092.debug

as you can see at [1], today I had to install those debuginfos and to be able to  pass them to dnf I had to save those lines in a text file and edit it with sed and other tools, in order to get a unique line like

dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/42/f85aee52ad1ef602493384599f9cc5055f06a0.debug /usr/lib/debug/.build-id/ee/241d6a833a2b4aadd9c9d24466002df2bce092.debug /usr/lib/debug/.build-id/83/24badd3109c04ae55f231acd78f34319a18b16.debug /usr/lib/debug/.build-id/4d/7ef10c0728e8a11e8cf653edac880f0bb986f5.debug /usr/lib/debug/.build-id/09/0c722eda060ab6a77b621b04e712f733bbeacc.debug /usr/lib/debug/.build-id/2a/adb90c29ba72dc5cff971e5441200d1d40eef0.debug /usr/lib/debug/.build-id/ba/2c41b0a92431f273c06e00a98f978b6b6f6bc8.debug [cut]

without the repetition of lines

Missing separate debuginfo for
Try: dnf --enablerepo='*debug*'


I would like to ask you if you can manage to implement with upstream help, a way to have such dependencies in a more confortable way, so that a user can easly paste them in another shell to let dnf install them

Version-Release number of selected component (if applicable):
gdb-8.0.1-36.fc27.x86_64

[1]:
Missing separate debuginfo for /lib64/libx264.so.148
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ee/241d6a833a2b4aadd9c9d24466002df2bce092.debug
Missing separate debuginfo for /lib64/libmp3lame.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/83/24badd3109c04ae55f231acd78f34319a18b16.debug
Missing separate debuginfo for /lib64/libsamba-util.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/4d/7ef10c0728e8a11e8cf653edac880f0bb986f5.debug
Missing separate debuginfo for /usr/lib64/samba/libreplace-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/09/0c722eda060ab6a77b621b04e712f733bbeacc.debug
Missing separate debuginfo for /usr/lib64/samba/libmsrpc3-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/2a/adb90c29ba72dc5cff971e5441200d1d40eef0.debug
Missing separate debuginfo for /usr/lib64/samba/liblibcli-lsa3-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ba/2c41b0a92431f273c06e00a98f978b6b6f6bc8.debug
Missing separate debuginfo for /usr/lib64/samba/liblibsmb-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/2b/c389d894a125e590430f2c7d5774aff3effdd3.debug
Missing separate debuginfo for /lib64/libndr.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/0d/f77a2e8309e7997ac92819ac6f0cf18c8e4904.debug
Missing separate debuginfo for /lib64/libsmbconf.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ee/e35539fe95e640bc1c786bdddb4a3ba038cc28.debug
Missing separate debuginfo for /usr/lib64/samba/libsamba-security-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/39/b30bd532e862f28700034199a2d090cc76ea91.debug
Missing separate debuginfo for /usr/lib64/samba/libsamba-debug-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/d5/9de5f357e9fce08df80b02f8e8e724ad236642.debug
Missing separate debuginfo for /lib64/libsamba-errors.so.1
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/79/383f93fbd431cb7c1008850ca6ed74696fb961.debug
Missing separate debuginfo for /lib64/libtevent-util.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/f3/f09918cc60561a73ed99dfcf98be0248da3dbb.debug
Missing separate debuginfo for /usr/lib64/samba/libgse-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/a1/cffb90b30ddb14c5bfa7ab5f56a61647fc8290.debug
Missing separate debuginfo for /lib64/libndr-standard.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/80/bdb552c455171f358fb0ae0b0091769ad53d39.debug
Missing separate debuginfo for /usr/lib64/samba/libdcerpc-samba-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/f4/8048e19568f6ebae3422bcffd8c6da6c511fa9.debug
Missing separate debuginfo for /usr/lib64/samba/libcli-smb-common-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/dd/c90166d3036acf79a393aac477f4f01e4b409c.debug
Missing separate debuginfo for /usr/lib64/samba/libutil-cmdline-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/fb/7115f21fa4311954f36edeebda4d95d9f37088.debug
Missing separate debuginfo for /usr/lib64/samba/libsamba3-util-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/a7/17d522762f18d32e3159e77ed59eecb366dbb1.debug
Missing separate debuginfo for /usr/lib64/samba/libsecrets3-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/6e/fefa8463fe9342e344a74ad234672a96e81345.debug
Missing separate debuginfo for /lib64/libfftw3.so.3
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/4b/6ffe3953e10ee901843050ed6c2ab57290a84f.debug
Missing separate debuginfo for /lib64/libnuma.so.1
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/c6/68e589debbfe6ace2218527a357599ffd4836a.debug
Missing separate debuginfo for /lib64/libgomp.so.1
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/75/127e1511dbe06cb26bbc66ef605beb6324415b.debug
Missing separate debuginfo for /usr/lib64/samba/libtime-basic-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/3e/d66e7ef07ee04ddf03cd3f0746384636ba76b8.debug
Missing separate debuginfo for /usr/lib64/samba/libaesni-intel-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/f1/40943b951866b68b58ff35dde58763beca30e2.debug
Missing separate debuginfo for /usr/lib64/samba/libgenrand-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/28/29a020e598bfddaeaf4baae649b5a9c980bebe.debug
Missing separate debuginfo for /usr/lib64/samba/libsocket-blocking-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/3c/48303211722210e34a8513d70885e5e2c51453.debug
Missing separate debuginfo for /usr/lib64/samba/libsys-rw-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/9a/8999e8880d26ef657fb61a96b773f42fd2007a.debug
Missing separate debuginfo for /lib64/libsamba-credentials.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/f0/e76288c231330935eb3029bbe29247b81e1330.debug
Missing separate debuginfo for /usr/lib64/samba/libndr-samba-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/6b/7acfea69df69c29b2e093f268bab69d8f82a3b.debug
Missing separate debuginfo for /lib64/libsamba-hostconfig.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/77/23dd79da2a4f8ff633128ed39fd405b0364f01.debug
Missing separate debuginfo for /usr/lib64/samba/libdbwrap-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/61/26d9d8fa8a3e9fb4c4b3175062dab0bb5f6d16.debug
Missing separate debuginfo for /usr/lib64/samba/libcliauth-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/5a/e596b55fe731cf132767ebe70063ec037b1768.debug
Missing separate debuginfo for /lib64/libdcerpc-binding.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/29/1007c839cfcd6ccb502ff73eec38131896df8c.debug
Missing separate debuginfo for /usr/lib64/samba/libutil-tdb-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/59/b0aeb96c416cf73609e3f37afd5580b6b96eda.debug
Missing separate debuginfo for /usr/lib64/samba/libsamba-sockets-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/d7/164245d77ba3d150697a7e851e31dd4116f0bf.debug
Missing separate debuginfo for /usr/lib64/samba/libgensec-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/9d/3cac43722836503e0561f9686fa0c430fff87f.debug
Missing separate debuginfo for /usr/lib64/samba/libasn1util-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/30/3688aaf4e34df269cfc3d58a48e69beb82b000.debug
Missing separate debuginfo for /usr/lib64/samba/libcli-cldap-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/d6/7679e97d76420be20f278fad8648d30f1852d1.debug
Missing separate debuginfo for /usr/lib64/samba/libCHARSET3-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/cf/5fd74af9cecca8ad75751b7da78e3fb393c247.debug
Missing separate debuginfo for /lib64/libndr-nbt.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/5c/f59001215978ca847c35a8e363af38c940a413.debug
Missing separate debuginfo for /usr/lib64/samba/libsmb-transport-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/9e/b7266a87c36cdace4a2f758003b7c382d837b0.debug
Missing separate debuginfo for /usr/lib64/samba/libinterfaces-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/fa/4c43ef4959937f13f063c548c50fd56ece38c8.debug
Missing separate debuginfo for /usr/lib64/samba/libtalloc-report-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/52/7079508bc189838126a5fe67f0cf5ec3af0f97.debug
Missing separate debuginfo for /usr/lib64/samba/libmessages-dgm-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ed/722a6f4b62a883cff2c925f10b0392f870aca6.debug
Missing separate debuginfo for /usr/lib64/samba/libsmbd-shim-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/63/164c1979f3ec73d20af512582d8d337e4a23d0.debug
Missing separate debuginfo for /usr/lib64/samba/libserver-id-db-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/9c/e58aa465347a211f7f157fc6984f0d0ee313bc.debug
Missing separate debuginfo for /usr/lib64/samba/libiov-buf-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/20/df322e5fc05a0d77c46ccb8922f9abed1a85f8.debug
Missing separate debuginfo for /usr/lib64/samba/libsamba-cluster-support-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/9c/a17f256a6f402b1c50d76100cd269444bbee7f.debug
Missing separate debuginfo for /usr/lib64/samba/libutil-reg-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/bc/2483ee46f8e046d554a5c4df8d2340e874d7c5.debug
Missing separate debuginfo for /usr/lib64/samba/libmessages-util-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/25/181eb54fa1df72f17226a73ef6e6675e244be5.debug
Missing separate debuginfo for /usr/lib64/samba/libutil-setid-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/74/0885094bef8859bafe5c7d1ad72da3d22e42fd.debug
Missing separate debuginfo for /usr/lib64/samba/libtdb-wrap-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ed/853bdd5793dea6609a4be18c0bb5b304bf4866.debug
Missing separate debuginfo for /usr/lib64/samba/libserver-role-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/e1/92cb6c76ca93ab9adc6279dc11610e2e778c95.debug
Missing separate debuginfo for /usr/lib64/samba/libaddns-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/ba/63b88a67fc357bd5bbf1bf73ab434edc99243f.debug
Missing separate debuginfo for /usr/lib64/samba/libkrb5samba-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/15/e18f5298599c8c68c8bfbf986947d0bf37fbbd.debug
Missing separate debuginfo for /usr/lib64/samba/libauthkrb5-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/b1/17a1318981f225171d63cdb94ba522eaad5c40.debug
Missing separate debuginfo for /usr/lib64/samba/libcli-nbt-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/c5/84bea6b5e0adf50b5b99c0b112acb06c06335a.debug
Missing separate debuginfo for /usr/lib64/samba/libsamdb-common-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/56/e7bd5a31803dad469a65393fffab684668b561.debug
Missing separate debuginfo for /usr/lib64/samba/libldbsamba-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/3f/315d417d25db9289ad0c3a86851f944bc7d59f.debug
Missing separate debuginfo for /lib64/libwbclient.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/0d/80722c6b6b7bb129898af56946b1e6d9e8dbb7.debug
Missing separate debuginfo for /usr/lib64/samba/libsamba-modules-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/e3/657290f27f5e3250565fd8f3625ccc78dda15b.debug
Missing separate debuginfo for /lib64/libsamdb.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/03/cf6ab01af693152746b813a95c166cac6dc574.debug
Missing separate debuginfo for /usr/lib64/samba/libcommon-auth-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/97/15a7423e80c5e9f91c18922d0caf8f7890d041.debug
Missing separate debuginfo for /usr/lib64/samba/libcli-ldap-common-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/98/a409376e07cc610aa98142ac9de3c2a02b9a37.debug
Missing separate debuginfo for /usr/lib64/samba/libmsghdr-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/a6/3353e30abab21cfd7f30bb9934b343a48d805d.debug
Missing separate debuginfo for /lib64/libndr-krb5pac.so.0
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/74/528fecc104c11df9710b0931a61a8a918d4be1.debug
Missing separate debuginfo for /usr/lib64/samba/libflag-mapping-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/46/1f462495138e1ae3cbd00a97313ea3256aa0c2.debug
Missing separate debuginfo for /usr/lib64/samba/libwinbind-client-samba4.so
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/0c/00304d26e0bd408e048469a1ab577a8c7cca9b.debug
Missing separate debuginfo for /lib64/libx265_main12.so.130
Try: dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/3a/addfed5a4ecf4bc0d554f5a714331eab369132.debug

Comment 1 Jan Kratochvil 2018-04-25 16:25:39 UTC
I do such merging by hand, those are few keystrokes in VIM so I do not find them such a burden.

I agree it could be printed in a better way but normally GDB should print package names which get printed together (this line is from very old GDB):
  Missing separate debuginfos, use: debuginfo-install glibc.i686 ncurses.i386 readline.i386 zlib.i386

This "dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/..." commmand was not expected to be normally printed to users, it happens because current Fedora debug info has changed and something in rpm or dnf or GDB needs to be updated:
  The dnf debuginfo-install plugin should also install the -debugsources package
  https://bugzilla.redhat.com/show_bug.cgi?id=1494628

But then this whole Fedora build-id patches has been reworked for more seamless upstreaming and so this Fedora patchset is in fact dead now and I am reluctant to make more updates of it (although I sometimes have to do some).
  [PATCH v12 00/32] Validate binary before use
  https://sourceware.org/ml/gdb-patches/2015-08/msg00590.html
But its upstream approval process somehow died.

Comment 2 Ben Cotton 2018-11-27 16:02:07 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Ben Cotton 2019-02-19 17:11:42 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 30 development cycle.
Changing version to '30.

Comment 4 Ben Cotton 2020-04-30 20:14:31 UTC
This message is a reminder that Fedora 30 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 30 on 2020-05-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '30'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 30 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 5 Ben Cotton 2020-08-11 15:29:38 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 33 development cycle.
Changing version to 33.

Comment 6 Sergio Basto 2020-08-28 23:42:15 UTC
Hi, 

I don't know if I should open a new bug but it is related to this  message of --enablerepo='*debug* ... 

instead of 

    dnf --enablerepo='*debug*' install /usr/lib/debug/.build-id/69/b41b2860e58dc8dfd849fb73ca4a5d8a7676d0.debug

We can use 

    dnf debuginfo-install /usr/lib/debug/.build-id/69/b41b2860e58dc8dfd849fb73ca4a5d8a7676d0.debug

which works perfectly.

At least could we change the message ? 
should I open a new report ? 

Thanks

Comment 7 Kevin Buettner 2020-08-30 01:48:46 UTC
(In reply to Sergio Basto from comment #6)
> Hi, 
> 
> I don't know if I should open a new bug but it is related to this  message
> of --enablerepo='*debug* ... 
> 
> instead of 
> 
>     dnf --enablerepo='*debug*' install
> /usr/lib/debug/.build-id/69/b41b2860e58dc8dfd849fb73ca4a5d8a7676d0.debug
> 
> We can use 
> 
>     dnf debuginfo-install
> /usr/lib/debug/.build-id/69/b41b2860e58dc8dfd849fb73ca4a5d8a7676d0.debug
> 
> which works perfectly.
> 
> At least could we change the message ? 
> should I open a new report ? 
> 
> Thanks

Hi Sergio,

It is related, but is different enough (IMO) for it to be a new bug.  Please file a new bug report.

Also, I wonder if the problem in the original report still exists?  When I see a missing debuginfo message from GDB, it typically provides a single command instead of a bunch of separate dnf commands as shown in the original report.  I'm inclined to close this particular bug, but will wait a few days in case someone can point me at a circumstance where multiple dnf commands are printed by GDB.

Comment 8 Jan Kratochvil 2020-08-30 07:38:59 UTC
(In reply to Kevin Buettner from comment #7)
> When I
> see a missing debuginfo message from GDB, it typically provides a single
> command instead of a bunch of separate dnf commands as shown in the original
> report.

Those are two different cases. When GDB can lookup the needed debuginfo package it will use "dnf debuginfo-install NVRA1 NVRA2...". But if it cannot find out the NVRA for whatever reason (and the debuginfo is missing which is why it gets into that GDB codepath) it will print the build-id as "dnf --disablerepo='*' --enablerepo=XXX build-id" (and those build-ids are not coalesced - that is a bug probably -
+       /* We do not collect and flush these messages as each such message
+          already requires its own separate lines.  */
). You can simulate the second case easily if you have installed debuginfo for a package and you do "mv /usr/lib/debug{,-x}" - then according to rpm database the debuginfo is installed but it still does not work for GDB so it will print the second (build-id) form.


(In reply to Sergio Basto from comment #6)
> We can use 
> 
>     dnf debuginfo-install
> /usr/lib/debug/.build-id/69/b41b2860e58dc8dfd849fb73ca4a5d8a7676d0.debug
> 
> which works perfectly.

I believe it did not work in the past so one should be careful to verify it works in supported RHEL releases by DTS (and make the change conditional otherwise).

Comment 9 Jan Kratochvil 2020-08-31 19:30:47 UTC
Kevin,

https://src.fedoraproject.org/rpms/gdb/tree/master
These gdb-6.6-buildid-locate*.patch files are there since 2007:
  https://src.fedoraproject.org/rpms/gdb/c/4e2e7886e3ed876840c4ce00fe6e0ea4e1acd5cb

(In reply to Jan Kratochvil from Bug 1624912 Comment #2)
> But then this whole Fedora build-id patchset has been reworked for more
> seamless upstreaming and so this Fedora patchset is in fact dead now and I am
> reluctant to make more updates of it (although I sometimes had to do some).
>   [PATCH v12 00/32] Validate binary before use
>   https://sourceware.org/ml/gdb-patches/2015-08/msg00590.html
> But its upstream approval process somehow died. And I am no longer working
> on GDB.

So if anything one should rather upstream that:
  https://sourceware.org/ml/gdb-patches/2015-08/msg00590.html

But then there is debuginfod client which is already upstream in GDB which may theoretically replace the whole *-debuginfo.rpm distribution method. But FChE was saying we still need to rely also on the *-debuginfo.rpm distribution for whatever reason as debuginfod servers are not always available.

Comment 10 Jan Kratochvil 2020-08-31 19:49:31 UTC
(In reply to Jan Kratochvil from comment #9)
> So if anything one should rather upstream that:
>   https://sourceware.org/ml/gdb-patches/2015-08/msg00590.html

Although that patchset was written still in the time Pedro was still resisting to switch GDB to C++ and big (most of) part of the patchset are just C workarounds of the missing C++ so that patchset would also require some heavy refactoring to make it sane.

Comment 11 Sergio Basto 2020-08-31 21:17:35 UTC
OK we have a new bug report here : https://bugzilla.redhat.com/show_bug.cgi?id=1874275

Comment 12 Germano Massullo 2020-10-02 16:47:27 UTC
(In reply to Jan Kratochvil from comment #1)
> I do such merging by hand, those are few keystrokes in VIM so I do not find
> them such a burden.

Can you please write a list of VIM commands in order to achieve that? I am right now merging all related debuginfo of qemu-system-x86_64 package.
Than you

Comment 13 Jan Kratochvil 2020-10-02 19:25:10 UTC
dnf --enablerepo='*debug*' install $(sed <COPYPASTEDFILE -n 's/^.* install //p')


Note You need to log in before you can comment on or make changes to this bug.